=== debian/changelog ===
stockfish (12-0.1~mx19+1) mx; urgency=medium

  * New upstream version.
  * Remove d/README.source; no longer applies with dh 10.
  * Update long description in d/control.
  * Install README.md in docs instead of Readme.md.
  * Refresh cxxflags.patch.
  * d/rules:
    - Add new neural networking nn-82215d0fd0df.nnue file to /debian and copy it
      into /src before build in order to avoid a forbidden download of it.
    - Drop "-old" from x86-32 profile build, no longer supported.
 
 -- Steven Pusser <stevep@mxlinux.org>  Tue, 08 Dec 2020 08:31:21 -0800
