=== debian/control ===
Source: stockfish
Section: games
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Maintainer: Milan Zamazal <pdm@debian.org>
Build-Depends: debhelper (>= 10)
Standards-Version: 4.5.0
Homepage: https://stockfishchess.org

Package: stockfish
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: polyglot, xboard | scid
Description: very strong chess engine, to play chess against
 Stockfish is not a complete chess program and requires a UCI-compatible
 graphical user interface (GUI) (e.g. XBoard with PolyGlot, Scid, Cute Chess,
 eboard, Arena, Sigma Chess, Shredder, Chess Partner or Fritz) in order
 to be used comfortably. Read the documentation for your GUI of choice for
 information about how to use Stockfish with it.
 .
 The Stockfish engine features two evaluation functions for chess, the classical
 evaluation based on handcrafted terms, and the NNUE evaluation based on
 efficiently updateable neural networks. The classical evaluation runs
 efficiently on almost all CPU architectures, while the NNUE evaluation benefits
 from the vector intrinsics available on most CPUs (sse2, avx2, neon, or
 similar). NNUE should be embedded in this binary distribution package.
