=== debian/changelog ===
stockfish (14.1-1) unstable; urgency=medium

  * New upstream version; closes: #1001265.
  * Standards 4.6.0 (no real change).

 -- Milan Zamazal <pdm@debian.org>  Fri, 31 Dec 2021 19:39:06 +0100

stockfish (12-2) unstable; urgency=medium

  * Fix FBTFS on i386; thanks to Sven Joachim; closes: #979519.

 -- Milan Zamazal <pdm@debian.org>  Thu, 07 Jan 2021 21:18:11 +0100

stockfish (12-1) unstable; urgency=medium

  * New upstream version.
  * Standards 4.5.1 (no real change).

 -- Milan Zamazal <pdm@debian.org>  Wed, 06 Jan 2021 20:35:55 +0100
