## stockfish 15

=== debian/changelog ===
stockfish (15-0.1~mx21+1) mx; urgency=medium

  * New upstream release, build for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 29 Oct 2022 15:08:35 -0700
