=== debian/changelog ===
stockfish (15.1-4) unstable; urgency=medium

  * Yet another attempt of -latomic fix; thanks to Adrian Bunk for
    providing and testing the fix.

 -- Milan Zamazal <pdm@debian.org>  Wed, 15 Feb 2023 22:21:58 +0100

stockfish (15.1-3) unstable; urgency=medium

  * Use -latomic on `general-32' architecture.

 -- Milan Zamazal <pdm@debian.org>  Tue, 14 Feb 2023 20:30:18 +0100

stockfish (15.1-2) unstable; urgency=medium

  * Standards 4.6.2 (no real change).
  * Make sure -latomic is used on armel and mipsel; closes: #1030525.

 -- Milan Zamazal <pdm@debian.org>  Mon, 14 Feb 2023 19:12:38 +0100

stockfish (15.1-1) unstable; urgency=medium

  * New upstream version; closes: #1023319.
  * Standards 4.6.1 (no real change).

 -- Milan Zamazal <pdm@debian.org>  Mon, 05 Dec 2022 19:54:27 +0100
