=== debian/changelog ===
stockfish (16-1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 13:11:42 +0200

stockfish (16-1) unstable; urgency=medium

  * New upstream version.
  * Fix FTCBFS: Defer stripping to dh_strip; thanks to Helmut Grohne;
    closes: #1051456.
  * Standards 4.6.2 (no real change).

 -- Milan Zamazal <pdm@debian.org>  Sat, 11 Nov 2023 21:21:24 +0100
