=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: stockfish
 Section: games
 Priority: optional
-Maintainer: Milan Zamazal <pdm@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Milan Zamazal <pdm@debian.org>
 Build-Depends: debhelper (>= 10)
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://stockfishchess.org
 
 Package: stockfish
