=== debian/rules ===
--- 
+++ 
@@ -12,10 +12,6 @@
 include /usr/share/dpkg/architecture.mk
 
 TARGET := profile-build ARCH=general-$(DEB_HOST_ARCH_BITS)
-
-ifeq (i386,$(DEB_HOST_ARCH_CPU))
-TARGET := profile-build ARCH=x86-32
-endif
 
 ifneq (,$(findstring amd64,$(DEB_HOST_ARCH)))
 TARGET := profile-build ARCH=x86-64
@@ -91,15 +87,12 @@
 TESTCMD := cd src && ./stockfish bench 32 1 10 default depth
 endif
 
+
 %:
 	dh $@ --sourcedirectory=src
 
 override_dh_auto_clean:
-	cd src && rm -rf *.gcda nn-82215d0fd0df.nnue && touch .depend && make clean
-
-override_dh_auto_configure:
-	cp debian/nn-82215d0fd0df.nnue src/
-	dh_auto_configure
+	cd src && rm -rf *.gcda && touch .depend && make clean
 
 override_dh_auto_build:
 	dh_auto_build --sourcedirectory=src -- $(TARGET2)
@@ -107,8 +100,8 @@
 override_dh_auto_test:
 	$(TESTCMD)
 
+override_dh_auto_install:
+	dh_auto_install -O--sourcedirectory=src -- PREFIX=debian/stockfish/usr STRIP=true
+
 override_dh_installman:
 	dh_installman debian/stockfish.6
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
